
(*
 * power : int * int -> int
 * REQUIRES: k >= 0
 * ENSURES: power (n, k) ==> n^k (where 0^0 is defined as 1)
 *)

fun power (n:int, k:int) = 
  (case (k, k mod 2) of 
      (0, _) => 1

    | (_, 0) => 
      let 
        val root = power (n, k div 2)
      in 
        root * root 
      end 

    | _ => n * power (n, k - 1)
  )


val 1 = power (5, 0)
val 1 = power (0, 0)
val 25 = power (5, 2)
val 1 = power (~1, 2)